CdmFilterablePagingProviderFactory.taxonNamesWithoutOrthographiclncorrect() causes
Status: New Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 0%
Category: cdm-vaadin Estimated time: 0:00 hour
Target version: Reviewed Next Major Release

Severity: normal Found in Version: Release 5.5
Description

in

CdmpFilterablePagingProviderFactory.taxonNamesWithoutOrthophiclncorrect()
a restriction is being used which causes the pager requests to be slow:

pagingProvider.addRestriction (new Restriction<>("relationsFromThisName.type", Operator.AND_NOT,
null, NameRelationshipType.ORTHOGRAPHIC_VARIANT ()));

With this restriction the pager takes ~5 on average per call, without this restriction only ~240 ms

Associated revisions

Revision 8d8da57a - 02/21/2019 12:40 PM - Andreas Kohlbecker

ref #8117 commenting orthographic corrected names filter to prevent from unclear performance probelms, see ref #7899

Revision b599ad36 - 02/21/2019 04:46 PM - Andreas Kohlbecker

ref #8117 commenting orthographic corrected names filter to prevent from unclear performance probelms, see ref #7899

History

#1 - 02/21/2019 11:32 AM - Andreas Kohlbecker

- Found in Version set to Release 5.5

#2 - 02/21/2019 11:37 AM - Andreas Kohlbecker

- Description updated

#3 - 02/21/2019 12:24 PM - Andreas Kohlbecker
- File picture278-1.png added

The query created by the restriction performs not so bad (55ms):

select

this_.id as 1d1_499_2_, this_.created as created2_499_2_, this_.createdBy_id as created40_499_2_, this_
uuid as uuid3_499_2_, this_.updated as updated4_499_2_, this_.updatedBy_id as updated41_499_2_, this_.
1sid_authority as lsid_aut5_499_2_, this_.lsid_lsid as 1lsid_1si6_499_2_, this_.lsid_namespace as
lsid_nam7_499_2_, this_.lsid_object as lsid_obj8_499_2_, this_.lsid_revision as lsid_rev9_499_2_ , this_.
protectedTitleCache as protectl0_499_2_, this_.titleCache as titleCall_499_2_, this_.acronym as
acronyml2_499_2_, this_.anamorphic as anamorpl3_499_2_, this_.appendedPhrase as appendel4_499_2_, this_.
authorshipCache as authorsl15_499_2_, this_.basionymAuthorship_id as basiony42_499_2_, this_.binomHybrid as
binomHy1l6_499_2_, this_.breed as breedl7_499_2_, this_.combinationAuthorship_id as combina43_499_2_, this_.
cultivarName as cultival8_499_2_, this_.exBasionymAuthorship_id as exBasio44_499_2_, this_.
exCombinationAuthorship_id as exCombi45_499_2_ , this_.fullTitleCache as fullTit19_499_2_ , this_.
genusOrUninomial as genusOr20_499_2_, this_.homotypicalGroup_id as homotyp46_499_2_, this_.hybridFormula as
hybridF21_499_2_, this_.inBasionymAuthorship_id as inBasio47_499_2_, this_.inCombinationAuthorship_id as
inCombi48_499_2_, this_.infraGenericEpithet as infraGe22_499_2_ , this_.infraSpecificEpithet as
infraSp23_499_2_, this_.monomHybrid as monomHy24_499_2_ , this_.nameApprobation as nameApp25_499_2_, this_.
nameCache as nameCac26_499_2_, this_.nameType as nameTyp27_499_2_, this_.nomenclaturalMicroReference as
nomencl28_499_2_, this_.nomenclaturalReference_id as nomencl49_499_2_ , this_.nomenclaturalSource_id as
nomencl50_499_2_, this_.originalPublicationYear as origina29_499_2_, this_.parsingProblem as parsing30_499_2_,
this_.problemEnds as problem31_499_2_, this_.problemStarts as problem32_499_2_ , this_
protectedAuthorshipCache as protect33_499_2_, this_.protectedFullTitleCache as protect34_499_2_, this_
protectedNameCache as protect35_499_2_, this_.publicationYear as publica36_499_2_ , this_.rank_id as
rank_id51_499_2_, this_.specificEpithet as specifi37_499_2_, this_.subGenusAuthorship as subGenu38_499_2_,
this_.trinomHybrid as trinomH39_499_2_, rank2_.id as id2_99_0_, rank2_.created as created3_99_0_, rank2_
createdBy_id as created41_99_0_, rank2_.uuid as uuid4_99_0_, rank2_.updated as updated5_99_0_, rank2_
updatedBy_id as updated42_99_0_, rank2_.lsid_authority as lsid_aut6_99_0_, rank2_.lsid_lsid as 1lsid_1si7_99_0_
, rank2_.lsid_namespace as lsid_nam8_99_0 rank2_.lsid_object as 1lsid_obj9_99_0_, rank2_.lsid_revision as

Y

1sid_rel0_99_0_, rank2_.protectedTitleCache as protectll_99_0_, rank2_.titleCache as titleCal2_99_0_, rank2_
termType as termTypl3_99_0_, rank2_.uri as urild4_99_0_, rank2_.idInVocabulary as idInVocl5_99_0_, rank2_
kindOf_id as kindOf_43_99_0_, rank2_.partOf_id as partOf_44_99_0_, rank2_.symbol as symboll6_99_0_, rank2_
symbol2 as symboll7_99_0_, rank2_.vocabulary_id as vocabul45_99_0_, rank2_.orderIndex as orderIn20_99_0_,
rank2_.rankClass as rankClad40_99_0_, representa3_.DefinedTermBase_id as DefinedTl1l_123_4_, representad_.id as
represen2_123_4_, representa4d4_.id as idl_423_1_, representad_.created as created2_423_1_, representad_
createdBy_id as createdB8_423_1_, representad_.uuid as uuid3_423_1_, representad4_.updated as updated4_423_1_,
representad_.updatedBy_id as updatedB9_423_1_, representa4d_.language_id as languaglO_423_1_, representad_.text
as text5_423_1_, representad_.abbreviatedLabel as abbrevia6_423_1_, representad4_.label as label7_423_1_

from

TaxonName this_

left outer join DefinedTermBase rank2_ on this_.rank_id=rank2_.id

left outer join DefinedTermBase_Representation representa3_ on rank2_.id=representa3_.DefinedTermBase_id

left outer join Representation representad_ on represental3_.representations_id=representad_.id

where this_.id in (

select distinct this_.id as yO_ from TaxonName this_ left
outer join NameRelationship relationsfl_ on this_.id=relationsfl_.relatedFrom_id
where ((1=1 and (lower (this_.titleCache) like 'Geis%')) and ((not (relationsfl_.type_id=915)
or relationsfl_.type_id is null)))
)
order by this_.titleCache asc limit 20

but the profiler reports ~5 seconds for this mysql query:

[| Hide nested calls | | Group queries by SQLtype | |Include prepareStatement()/jprepareCalll) || Hide zero time calls
rela x call Time (ms) Avg. Time (ms) Invocation count
ype_id=?) or relationsfl_type_id is null)))) order by this_titleCache asc limit ? 11,421 22% 5,710 2
cype_id=7) or relationsfl_type_id is null))}) limit ? 598 1% 299 2
Reverse Call Tree Time (ms) Invocation Count
= K com.mchange.v2.c3p0.impl. NewProxyPreparedStatement.executeQuery() NewProwPreparedstatement. java 11,421 100 % 2
El 5 org.hibernate.internal. Criterialmpl.list() Criteriaimpl.java: 363

& eu.etaxonomy.cdm.persistence. dao.hibernate.common.CdmEntityDaoBase.findByParamWithRestrictions((

#4 - 02/21/2019 12:29 PM - Andreas Kohlbecker
- File picture588-1.png added
the most time is actually consumed by

Call Tree Time (ms) Avg. Time (ms) Own Time (ms) Invocation Count
B Mysgllo 4 M com.mysgljdbe.uti. ReadAheadinputStream.read(byte(], int. int) 11,060 12% 5,330 < 0.1 2

E Re Stream.java:172 W com.mysgljdbe.util. ReadAheadinputStream.readFromUnderlying5 11,060 12 % 5,530 11,060 2
R 2:142 ] java.net.AbstractPlainSocketlmpl.isConnectionResetPending(’ 0 0% 4] 4] 2
MysqllO.j "‘42‘ N com, mysql]dbc MyEqIIO readFuIIyUnputStream byte[], int, int) =01 0% ~ <01 2

Do we need to update the mysql driver for some reason?

#5 - 02/21/2019 02:41 PM - Andreas Kohlbecker

Correction: The sql query showing the problem is:

select

this_.id as 1d1_499_2_, this_.created as created2_499_2_ , this_.createdBy_id as created40_499_2_, this_
uuid as uwuid3_499_2_, this_.updated as updated4_499_2_ , this_.updatedBy_id as updated41l_499_2_, this_
1lsid_authority as lsid_aut5_499_2_, this_.lsid_lsid as 1lsid_1si6_499_2_, this_.lsid_namespace as
lsid_nam7_499_2_, this_.lsid_object as lsid_obj8_499_2_ , this_.lsid_revision as lsid_rev9_499_2_, this_
protectedTitleCache as protectl1l0_499_2_, this_.titleCache as titleCall_499_2_, this_.acronym as
acronyml2_499_2_, this_.anamorphic as anamorpl3_499_2_, this_.appendedPhrase as appendel4_499_2_, this_
authorshipCache as authorsl5_499_2_ , this_.basionymAuthorship_id as basiony42_499_2_, this_.binomHybrid as
binomHy1l6_499_2_, this_.breed as breedl7_499_2_, this_.combinationAuthorship_id as combina43_499_2_, this_
cultivarName as cultival8_499_2_, this_.exBasionymAuthorship_id as exBasio44_499_2_, this_
exCombinationAuthorship_id as exCombi45_499_2_, this_.fullTitleCache as fullTitl19_499_2_, this_
genusOrUninomial as genusOr20_499_2_, this_.homotypicalGroup_id as homotyp46_499_2_, this_.hybridFormula as
hybridF21_499_2_, this_.inBasionymAuthorship_id as inBasio47_499_2_, this_.inCombinationAuthorship_id as
inCombi48_499_2_ , this_.infraGenericEpithet as infraGe22_499_2_, this_.infraSpecificEpithet as
infraSp23_499_2_, this_.monomHybrid as monomHy24_499_2_ , this_.nameApprobation as nameApp25_499_2_, this_.
nameCache as nameCac26_499_2_, this_.nameType as nameTyp27_499_2_, this_.nomenclaturalMicroReference as
nomencl28_499_2_ , this_.nomenclaturalReference_id as nomencl49_499_2_ , this_.nomenclaturalSource_id as
nomencl50_499_2_ , this_.originalPublicationYear as origina29_499_2_ , this_.parsingProblem as parsing30_499_2_,
this_.problemEnds as problem31_499_2_, this_.problemStarts as problem32_499_2_, this_.
protectedAuthorshipCache as protect33_499_2_, this_.protectedFullTitleCache as protect34_499_2_, this_.
protectedNameCache as protect35_499_2_, this_.publicationYear as publica36_499_2_, this_.rank_id as
rank_id51_499_2_, this_.specificEpithet as specifi37_499_2_, this_.subGenusAuthorship as subGenu38_499_2_,

this_.trinomHybrid as trinomH39_499_2_ , rank2_.id as 1d2_99_0_, rank2_.created as created3_99_0_, rank2_.

createdBy_id as created41l_99_0_, rank2_.uuid as uuid4_99_0_, rank2_.updated as updated5_99_0_, rank2_.
updatedBy_id as updated42_99_0_, rank2_.lsid_authority as lsid_aut6_99_0_, rank2_.lsid_lsid as 1lsid_1si7_99_0_
, rank2_.lsid_namespace as lsid_nam8_99_0_, rank2_.lsid_object as 1lsid_ob3j9_99_0_, rank2_ .lsid_revision as
1sid_rel0_99_0_, rank2_.protectedTitleCache as protectll_99_0_, rank2_.titleCache as titleCal2_99_0_, rank2_.
termType as termTypl3_99_0_, rank2_.uri as uril4_99_0_, rank2_.idInVocabulary as idInVocl5_99_0_, rank2_.
kindOf_id as kindOf_43_99_0_, rank2_.partOf_id as partOf_44_99_0_, rank2_.symbol as symboll6_99_0_, rank2_.
symbol2 as symboll7_99_0_, rank2_.vocabulary_id as vocabul45_99_0_, rank2_.orderIndex as orderIn20_99_0_,
rank2_.rankClass as rankClad40_99_0_, representa3_.DefinedTermBase_id as DefinedTl1l_123_4_, representa4d_.id as

represen2_123_4_, representad4_.id as 1idl1_423_1_, representad_.created as created2_423_1_, representad_.

createdBy_id as createdB8_423_1_, representa4_.uuid as uuid3_423_1_, representad_.updated as updated4_423_1_,
representad4_.updatedBy_id as updatedB9_423_1_, representa4_.language_id as languaglO_423_1_, representad_.text
as textb5_423_1_, representad_.abbreviatedLabel as abbrevia6_423_1_, representad_.label as label7_423_1_
from
TaxonName this_
left outer join DefinedTermBase rank2_ on this_.rank_id=rank2_.id
left outer join DefinedTermBase_Representation representa3_ on rank2_.id=representa3_.DefinedTermBase_id
left outer join Representation representad4_ on represental3_.representations_id=representad_.id
where this_.id in (
select distinct this_.id as yO_ from TaxonName this_ left
outer join NameRelationship relationsfl_ on this_.id=relationsfl_.relatedFrom_id
where ((1=1 and (lower (this_.titleCache) like '%')) and ((not (relationsfl_.type_id=915) or
relationsfl_.type_id is null)))
)
order by this_.titleCache asc limit 500

this one takes ~5s

#6 - 03/23/2022 10:50 AM - Andreas Miiller

- Subject changed from CdmpFilterablePagingProviderFactory.taxonNamesWithoutOrthophiclncorrect() casues performance overhead to
CdmfFilterablePagingProviderFactory.taxonNamesWithoutOrthophiclncorrect() causes performance overhead

#7 - 03/23/2022 10:50 AM - Andreas Miiller

- Subject changed from CdmpFilterablePagingProviderFactory.taxonNamesWithoutOrthophiclncorrect() causes performance overhead to
CdmfFilterablePagingProviderFactory.taxonNamesWithoutOrthographiclncorrect() causes performance overhead
